return {
    duck_whiff_punish = function(self, enemy, frames)
        print("duck_whiff_punish:" .. frames)  
        
        -- Generate a random button press delays
        local randomPressDuration = math.random(3, 7)
        local randomPressDuration2 = math.random(2, 5)
    
        -- Generate a random neutral delay between actions (1 to 4 frames)
        local function randomNeutralDelay()
            local delayDuration = math.random(1, 4)
            delayFrames(delayDuration)  -- Assuming delayFrames adds the delay
            print("Neutral delay of " .. delayDuration .. " frames")
        end
        
        -- Easily adjustable weight: Set the chance for Option 1 (L_HAND first)
        local weightOption1 = 40  -- 40% chance for Option 1 (L_HAND first), 60% chance for Option 2 (R_KICK first)
        
        -- Weighted random selection function
        local function weightedRandomSelection(weightOption1)
            local randomValue = math.random(0, 100)
            return randomValue <= weightOption1
        end
        
        if frames <= 11 then
            -- 1, 4 punish (strong and wall splats, leaves oki)            
            executeMacro(0, Input.R_KICK, randomPressDuration, InputType.KEY_PRESS)
            randomNeutralDelay()  -- Add random delay between actions
            executeMacro(0, Input.R_HAND, randomPressDuration2, InputType.KEY_PRESS)
            return
        end      
        
        if frames <= 12 then
            -- fc2 , gives heat engager
            executeMacro(Input.DOWN, 0, 2, InputType.KEY_DOWN)  -- Use KEY_DOWN to hold down      
            local direction = Input.DOWN | Input.FORWARD  -- Combine DOWN and FORWARD
            randomNeutralDelay()  -- Add random delay before executing df2
            executeMacro(direction, Input.R_HAND, randomPressDuration, InputType.KEY_PRESS)  -- Execute df2           
            return
        end
        
        if frames <= 14 then
            -- Choose between two punish options with weighted randomness, responding different makes it more real
            if weightedRandomSelection(weightOption1) then
                -- Option 1: 1, 4 punish (strong and wall splats, leaves oki)
                executeMacro(0, Input.L_HAND, randomPressDuration, InputType.KEY_PRESS)
                randomNeutralDelay()  -- Add random delay between actions
                executeMacro(0, Input.R_KICK, randomPressDuration2, InputType.KEY_PRESS)
                print("Executed: L_HAND then R_KICK")
            else
                -- Option 2: 4,2 punish (faster and leaves you plus for mixup)
                executeMacro(0, Input.R_KICK, randomPressDuration, InputType.KEY_PRESS)
                randomNeutralDelay()  -- Add random delay between actions
                executeMacro(0, Input.R_HAND, randomPressDuration2, InputType.KEY_PRESS)
                print("Executed: R_KICK then R_HAND")
            end
            return
        end
        
        if frames >= 15 then            
            executeMacro(0, Input.R_HAND, randomPressDuration, InputType.KEY_PRESS)
            return
        end
    end,    
    air_counters = function(self, enemy, frames)
        print("air counter" .. frames)  
    end,
    high_counters = function(self, enemy, frames)
        print("high counter" .. frames)  
    end,
    low_counters = function(self, enemy, frames)
        print("low counter" .. frames)  
    end,
    
    mid_counters = function(self, enemy, frames)
        print("mid counter" .. frames)
    end,
    onAttackCounter = function(self, enemy, frames)
        print("onattackcounter counter" .. frames)
    end,
    onAttackSuccess = function(self, enemy, frames)
    end,
    OnInitAttackProc = function(self, enemy, frames)
        --print("Default ID:" .. enemy.move_id, self.char_id)
    end

    
}